#include <xsTypes.h>
#include <XSContainer.h>
#include <XSstreams.h>
#include <XSFit/Fit/Fit.h>
#include <XSFit/Fit/FitMethod.h>        
#include <XSUser/Global/Global.h>
#include <XSUser/Global/XSGlobal.h>
#include <XSUtil/Error/Error.h>

int
XSGlobal::xsImprove(ClientData cdata,Tcl_Interp* tclInterp,int objc, Tcl_Obj* CONST  objv[])
{
   using namespace XSContainer;
   if (objc == 2 && string(Tcl_GetString(objv[1])) == "?")
   {
      printDocs(static_cast<char*>(cdata),"?");
      return globalData->autoSave(TCL_OK);
   }
   
   FitMethod* method = fit->fitMethod();
   if (!fit->isStillValid())
   {
      tcout << " A valid fit is required before improve command can be run."
         << std::endl;
      return globalData->autoSave(TCL_ERROR);          
   }
   
   try
   {
      method->improve(fit);
      fit->report();
   }
   catch (YellowAlert&)
   {
   }
   return globalData->autoSave(TCL_OK);
}
